import { __extends } from "tslib";
import caseOf from "../../function/caseOf";
import isFunction from "../../function/isFunction";
var Either = (function () {
    function Either() {
    }
    Either.of = function (v) {
        return new Right(v);
    };
    Either.Right = function (v) {
        return new Right(v);
    };
    Either.Left = function (v) {
        return new Left(v);
    };
    Either.fromNullable = function (v) {
        return v !== null || v !== undefined ? new Right(v) : new Left(v);
    };
    Either.withDefault = function (def, v) {
        return v.caseOf({ Left: function () { return Either.of(def); }, Right: function () { return v; } });
    };
    Either.swap = function (e) {
        return e.swap();
    };
    Either.try = function (f) {
        return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            try {
                return new Right(f.apply(null, args));
            }
            catch (e) {
                return new Left(e);
            }
        };
    };
    Either.bimap = function (e, fl, fr) {
        return e.bimap(fl, fr);
    };
    Either.isLeft = function (v) {
        return v.isLeft();
    };
    Either.isRight = function (v) {
        return v.isRight();
    };
    Either.prototype.of = function (v) {
        return new Right(v);
    };
    Either.prototype.ap = function (j) {
        return this.caseOf({
            Left: function (v) { return j; },
            Right: function (v) {
                if (!isFunction(v))
                    throw Error("Either: Wrapped value is not a function");
                return j.map(v);
            }
        });
    };
    Either.prototype.getValue = function () {
        return this._value;
    };
    return Either;
}());
Either.prototype["fantasy-land/equals"] = Either.prototype.equals;
Either.prototype["fantasy-land/map"] = Either.prototype.map;
Either.prototype["fantasy-land/bimap"] = Either.prototype.bimap;
Either.prototype["fantasy-land/chain"] = Either.prototype.chain;
Either.prototype["fantasy-land/of"] = Either.prototype.of;
Either.prototype["fantasy-land/ap"] = Either.prototype.ap;
var Left = (function (_super) {
    __extends(Left, _super);
    function Left(v) {
        var _this = _super.call(this) || this;
        _this._value = v;
        return _this;
    }
    Left.prototype.equals = function (n) {
        return (n instanceof Left &&
            n.isLeft &&
            n.isLeft() &&
            n.getValue() === this.getValue());
    };
    Left.prototype.map = function (f) {
        return new Left(this.getValue());
    };
    Left.prototype.bimap = function (fl, fr) {
        return new Left(fl(this.getValue()));
    };
    Left.prototype.chain = function (f) {
        return new Left(this.getValue());
    };
    Left.prototype.isRight = function () {
        return false;
    };
    Left.prototype.isLeft = function () {
        return true;
    };
    Left.prototype.swap = function () {
        return new Right(this.getValue());
    };
    Left.prototype.toString = function () {
        return "Left(" + this.getValue() + ")";
    };
    Left.prototype.caseOf = function (o) {
        if (o.Left)
            return o.Left(this.getValue());
        else
            throw Error("Either: Expected Left!");
    };
    return Left;
}(Either));
var Right = (function (_super) {
    __extends(Right, _super);
    function Right(v) {
        var _this = _super.call(this) || this;
        _this._value = v;
        return _this;
    }
    Right.prototype.equals = function (j) {
        return (j instanceof Right &&
            j.isRight &&
            j.isRight() &&
            j.getValue() === this.getValue());
    };
    Right.prototype.map = function (f) {
        if (!isFunction(f))
            throw Error("Either: Expected a function to map");
        return new Right(f(this.getValue()));
    };
    Right.prototype.bimap = function (fl, fr) {
        return new Right(fr(this.getValue()));
    };
    Right.prototype.chain = function (f) {
        if (!isFunction(f))
            throw Error("Either: Expected a function to chain");
        return f(this.getValue());
    };
    Right.prototype.isRight = function () {
        return true;
    };
    Right.prototype.isLeft = function () {
        return false;
    };
    Right.prototype.swap = function () {
        return new Left(this.getValue());
    };
    Right.prototype.toString = function () {
        return "Right(" + this.getValue() + ")";
    };
    Right.prototype.caseOf = function (o) {
        if (o.Right)
            return o.Right(this.getValue());
        else
            throw Error("Either: Expected Right");
    };
    return Right;
}(Either));
export default Either;
export var maybeToEither = function (m) {
    return caseOf({
        Nothing: function (v) { return Either.Left(null); },
        Just: function (v) { return Either.Right(v); }
    }, m);
};
