import Monad from "../../interface/Monad";
import Semigroup from "../../interface/Semigroup";
import Setoid from "../../interface/Setoid";
declare class Identity<A> implements Setoid, Semigroup, Monad<A> {
    private _value;
    constructor(value: A);
    static of<C>(v: C): Identity<C>;
    of<C>(v: C): Identity<C>;
    getValue(): A;
    equals(j: Identity<A>): boolean;
    concat(i: Identity<Semigroup>): Identity<A>;
    ap<B, C>(i: Identity<B>): Identity<C>;
    map<B>(f: (a: A) => B): Identity<B>;
    chain<B>(f: (a: A) => Identity<B>): Identity<B>;
    toString(): string;
}
export default Identity;
