import Alt from "../../interface/Alt";
import Monad from "../../interface/Monad";
import PatternMatch from "../../interface/Patternmatch";
import Setoid from "../../interface/Setoid";
import Either from "./../Either";
export default abstract class Maybe<A> implements Setoid, Monad<A>, Alt<A>, PatternMatch {
    protected _value: A;
    static of<B>(v: B): Maybe<B>;
    static zero<B>(): Maybe<B>;
    static Just<B>(v: B): Maybe<B>;
    static Nothing<B>(): Maybe<B>;
    static fromNullable<B>(v: any): Maybe<B>;
    static withDefault<B>(def: any, v: any): Maybe<B>;
    static catMaybes<B>(ar: Array<Maybe<B>>): Array<any>;
    static isNothing<B>(v: Maybe<B>): boolean;
    static isJust<B>(v: Maybe<B>): boolean;
    of<B>(v: B): Maybe<B>;
    alt<B>(v: Maybe<B>): Maybe<B>;
    ap<B, C>(j: Maybe<B>): Maybe<C>;
    getValue(): A;
    abstract equals(n: Setoid): boolean;
    abstract map<B>(f: (a: A) => B): Maybe<B>;
    abstract chain<B>(f: (a: A) => Maybe<B>): Maybe<B>;
    abstract caseOf(o: {
        Nothing: (a: any) => any;
        Just: (a: any) => any;
    }): any;
    abstract isNothing(): boolean;
    abstract isJust(): boolean;
}
export declare class Nothing<A> extends Maybe<A> {
    equals(n: Setoid): boolean;
    map<B>(f: (a: A) => B): Maybe<B>;
    chain<B>(f: (a: A) => Maybe<B>): Maybe<B>;
    isJust(): boolean;
    isNothing(): boolean;
    toString(): string;
    caseOf(o: {
        Nothing: Function;
    }): any;
}
export declare class Just<A> extends Maybe<A> {
    constructor(v: any);
    equals(j: Setoid): boolean;
    map<B>(f: (a: A) => B): Maybe<B>;
    chain<B>(f: (a: A) => Maybe<B>): Maybe<B>;
    isJust(): boolean;
    isNothing(): boolean;
    toString(): string;
    caseOf(o: {
        Just: Function;
    }): any;
}
export declare const eitherToMaybe: <A, B>(e: Either<A, B>) => any;
export declare const prop: Function;
