import BiFunctor from "../../interface/Bifunctor";
import Monad from "../../interface/Monad";
import Semigroup from "../../interface/Semigroup";
import Setoid from "../../interface/Setoid";
declare class Pair<A, B> implements Setoid, Semigroup, BiFunctor<A, B>, Monad<B> {
    private _value;
    constructor(v1: A, v2: B);
    static of<C>(v: C): Pair<C, C>;
    of<C>(v: C): Pair<C, C>;
    equals(j: Pair<A, B>): boolean;
    concat(p: Pair<Semigroup, Semigroup>): Pair<A, B>;
    fst(): A;
    snd(): B;
    ap<C, D>(j: Pair<C, B>): Pair<C, D>;
    getValue(): (A | B)[];
    map<C>(f: (a: B) => C): Pair<A, C>;
    bimap<C, D>(f1: (a: A) => C, f2: (a: B) => D): Pair<C, D>;
    chain<C, D>(f: (a: B) => Pair<C, D>): Pair<C, D>;
    swap(): Pair<A | B, A | B>;
    toString(): string;
}
export default Pair;
