import Monad from "../../interface/Monad";
declare class State<A, B> implements Monad<B> {
    private _value;
    constructor(fn: Function);
    static of<G, K>(v: G): State<unknown, unknown>;
    of<C, D>(v: C): State<unknown, unknown>;
    get(fn?: Function): State<A, B>;
    put(s: B): State<A, B>;
    runWith(s: A): any;
    execWith(s: A): any;
    evalWith(s: A): any;
    ap<C, D>(j: State<C, (b: B) => D>): State<C, D>;
    getValue(): Function;
    map<C>(f: Function): State<A, C>;
    chain<C, D>(f: (a: B) => State<C, D>): State<C, D>;
    toString(): string;
}
export default State;
