import isFunction from "../isFunction";
export default function curry(fn) {
    if (!isFunction(fn))
        throw Error("Function not provided");
    var slice = Array.prototype.slice;
    var arity = fn.length;
    return function curried() {
        var args = slice.call(arguments, 0);
        if (args.length >= arity)
            return fn.apply(null, args);
        return function () {
            return curried.apply(null, args.concat(slice.call(arguments)));
        };
    };
}
