import curry from "../curry";
import isFunction from "../isFunction";
function liftAn(f, fns) {
    if (!isFunction(f))
        throw Error("Expected a function");
    var init = fns[0].map(f);
    var res = init;
    if (fns.length > 1) {
        var rest = fns.slice(1);
        res = rest.reduce(function applyFn(a, ca) {
            return a.ap(ca);
        }, init);
    }
    return res;
}
export default curry(liftAn);
