import isFunction from "../isFunction";
export default function ocurry(fn, args) {
    if (!isFunction(fn))
        throw Error("Expected a function as first argument to ocurry");
    if (fn.length > 1)
        throw Error("Function passed as first argument should not take more than one argument. Argument should be a dictionary");
    return function ocurried(ar) {
        var curArgs = Object.keys(ar);
        var diff = args.filter(function (x) { return curArgs.indexOf(x) < 0; });
        if (diff.length > 0)
            return function (ar2) {
                return ocurried.call(null, Object.assign({}, ar, ar2));
            };
        return fn.call(null, ar);
    };
}
