import isFunction from "../isFunction";
export default function once(f) {
    if (!isFunction(f))
        throw Error("Function not provided");
    var _called = false;
    var _result;
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (!_called) {
            _called = true;
            _result = f.apply(null, args);
        }
        return _result;
    };
}
